(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@wm/components/base')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@wm/components/base'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.wm = global.wm || {}, global.wm.components = global.wm.components || {}, global.wm.components.page = global.wm.components.page || {}, global.wm.components.page.topnav = {}), global.ng.core, global.ng.common, global.wm.components.base));
})(this, (function (exports, i0, common, base) { 'use strict';

    function _interopNamespaceDefault(e) {
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n.default = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespaceDefault(i0);

    const registerProps = () => {
        base.register('wm-top-nav', new Map([
            ['name', base.PROP_STRING],
            ['content', base.PROP_STRING],
            ['hint', base.PROP_STRING],
            ['arialabel', base.PROP_STRING]
        ]));
    };

    const DEFAULT_CLS = 'app-top-nav';
    const WIDGET_CONFIG = { widgetType: 'wm-top-nav', hostClass: DEFAULT_CLS };
    class TopNavDirective extends base.StylableComponent {
        static { this.initializeProps = registerProps(); }
        constructor(inj, explicitContext) {
            super(inj, WIDGET_CONFIG, explicitContext);
            base.styler(this.nativeElement, this);
        }
        static { this.ɵfac = function TopNavDirective_Factory(t) { return new (t || TopNavDirective)(i0__namespace.ɵɵdirectiveInject(i0__namespace.Injector), i0__namespace.ɵɵdirectiveInject('EXPLICIT_CONTEXT', 8)); }; }
        static { this.ɵdir = /*@__PURE__*/ i0__namespace.ɵɵdefineDirective({ type: TopNavDirective, selectors: [["", "wmTopNav", ""]], exportAs: ["wmTopNav"], features: [i0__namespace.ɵɵProvidersFeature([
                    base.provideAsWidgetRef(TopNavDirective)
                ]), i0__namespace.ɵɵInheritDefinitionFeature] }); }
    }
    (() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(TopNavDirective, [{
            type: i0.Directive,
            args: [{
                    selector: '[wmTopNav]',
                    providers: [
                        base.provideAsWidgetRef(TopNavDirective)
                    ],
                    exportAs: 'wmTopNav'
                }]
        }], () => [{ type: i0__namespace.Injector }, { type: undefined, decorators: [{
                    type: i0.Inject,
                    args: ['EXPLICIT_CONTEXT']
                }, {
                    type: i0.Optional
                }] }], null); })();

    const components = [
        TopNavDirective
    ];
    class TopNavModule {
        static { this.ɵfac = function TopNavModule_Factory(t) { return new (t || TopNavModule)(); }; }
        static { this.ɵmod = /*@__PURE__*/ i0__namespace.ɵɵdefineNgModule({ type: TopNavModule }); }
        static { this.ɵinj = /*@__PURE__*/ i0__namespace.ɵɵdefineInjector({ imports: [common.CommonModule,
                base.WmComponentsModule] }); }
    }
    (() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(TopNavModule, [{
            type: i0.NgModule,
            args: [{
                    imports: [
                        common.CommonModule,
                        base.WmComponentsModule
                    ],
                    declarations: [...components],
                    exports: [...components]
                }]
        }], null, null); })();
    (function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(TopNavModule, { declarations: [TopNavDirective], imports: [common.CommonModule,
            base.WmComponentsModule], exports: [TopNavDirective] }); })();

    exports.TopNavDirective = TopNavDirective;
    exports.TopNavModule = TopNavModule;

}));
